#include "chip.h"
#include "chip_clk_constraints.h"
#include "chip_init_faults.h"
#if CHIP_LTIMER_EN
    #include "lclock.h"
#endif

#define CHIP_RVAL_RCC_CR_WTRDY_MSK    (CHIP_CLK_HSE_EN ? CHIP_REGFLD_RCC_CR_HSE_RDY : 0)


#if CHIP_CLK_PLL1_EN
    #if ((CHIP_CLK_HSE_PLLIN_DIV >= 1) && (CHIP_CLK_HSE_PLLIN_DIV <= 2))
        #define CHIP_RVAL_RCC_CFG_PLL1XTPRE     (CHIP_CLK_HSE_PLLIN_DIV - 1)
    #else
        #error "Invalid PLL HSE devider value"
    #endif

    #if (CHIP_CLK_PLL1_MUL == 2) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_2
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_2
    #elif  (CHIP_CLK_PLL1_MUL == 3) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_3
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_3
    #elif  (CHIP_CLK_PLL1_MUL == 4) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_4
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_4
    #elif  (CHIP_CLK_PLL1_MUL == 5) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_5
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_5
    #elif  (CHIP_CLK_PLL1_MUL == 6) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_6
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_6
    #elif  (CHIP_CLK_PLL1_MUL ==  (13/2)) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_6_5
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_6_5
    #elif  (CHIP_CLK_PLL1_MUL == 7) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_7
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_7
    #elif  (CHIP_CLK_PLL1_MUL == 8) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_8
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_8
    #elif  (CHIP_CLK_PLL1_MUL == 9) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_9
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_9
    #elif  (CHIP_CLK_PLL1_MUL == 10) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_10
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_10
    #elif  (CHIP_CLK_PLL1_MUL == 11) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_11
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_12
    #elif  (CHIP_CLK_PLL1_MUL == 12) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_12
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_12
    #elif  (CHIP_CLK_PLL1_MUL == 13) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_13
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_13
    #elif  (CHIP_CLK_PLL1_MUL == 14) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_14
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_14
    #elif  (CHIP_CLK_PLL1_MUL == 15) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_15
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_15
    #elif  (CHIP_CLK_PLL1_MUL == 16) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_16
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_16
    #elif  (CHIP_CLK_PLL1_MUL == 17) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_17
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_17
    #elif  (CHIP_CLK_PLL1_MUL == 18) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_18
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_18
    #elif  (CHIP_CLK_PLL1_MUL == 19) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_19
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_19
    #elif  (CHIP_CLK_PLL1_MUL == 20) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_20
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_20
    #elif  (CHIP_CLK_PLL1_MUL == 21) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_21
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_21
    #elif  (CHIP_CLK_PLL1_MUL == 22) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_22
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_22
    #elif  (CHIP_CLK_PLL1_MUL == 23) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_23
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_23
    #elif  (CHIP_CLK_PLL1_MUL == 24) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_24
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_24
    #elif  (CHIP_CLK_PLL1_MUL == 25) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_25
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_25
    #elif  (CHIP_CLK_PLL1_MUL == 26) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_26
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_26
    #elif  (CHIP_CLK_PLL1_MUL == 27) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_27
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_27
    #elif  (CHIP_CLK_PLL1_MUL == 28) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_28
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_28
    #elif  (CHIP_CLK_PLL1_MUL == 29) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_29
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_29
    #elif  (CHIP_CLK_PLL1_MUL == 30) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_30
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_30
    #elif  (CHIP_CLK_PLL1_MUL == 31) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_31
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_31
    #elif  (CHIP_CLK_PLL1_MUL == 32) && defined CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_32
        #define CHIP_RVAL_RCC_CFGR_PLL1MUL  CHIP_REGFLDVAL_RCC_CFGR_PLL1_MUL_32
    #else
        #error "Invalid PLL multiplier value"
    #endif


    #if !CHIP_CLK_PLL1IN_EN
        #error PLL clock source is not enabled
    #endif
    #if CHIP_CLK_PLL1_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_RVAL_RCC_CFGR_PLL1SRC      CHIP_REGFLDVAL_RCC_CFGR_PLL1_SRC_HSI
    #elif CHIP_CLK_PLL1_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_RVAL_RCC_CFGR_PLL1SRC      CHIP_REGFLDVAL_RCC_CFGR_PLL1_SRC_HSE
    #else
         #error Invalid PLL1 clock source
    #endif

    #ifdef CHIP_CLK_PLL1_FREQ_MIN
        #if ((CHIP_CLK_PLL1_FREQ < CHIP_CLK_PLL1_FREQ_MIN) || (CHIP_CLK_PLL1_FREQ > CHIP_CLK_PLL1_FREQ_MAX))
            #error PLL1 output freq is out of range
        #endif
    #endif
#endif


/* --------------------- Проверка параметров SystemClock -------------------- */
#if CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_RVAL_RCC_CFGR_SW    CHIP_REGFLDVAL_RCC_CFGR_SW_HSI
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_RVAL_RCC_CFGR_SW    CHIP_REGFLDVAL_RCC_CFGR_SW_HSE
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_PLL1_ID
    #define CHIP_RVAL_RCC_CFGR_SW    CHIP_REGFLDVAL_RCC_CFGR_SW_PLL1
#else
    #error Invalid System Clock Source (must be from HSI, HSE, PLL1)
#endif

#if !CHIP_CLK_SYS_EN
    #error System clock source is not enabled
#endif



/* -------------------- Проверка частот AHB ----------------------------------*/
#if CHIP_CLK_AHB_DIV == 1
    #define CHIP_RVAL_RCC_CFGR_HPRE             0
#elif CHIP_CLK_AHB_DIV == 2
    #define CHIP_RVAL_RCC_CFGR_HPRE             8
#elif CHIP_CLK_AHB_DIV == 4
    #define CHIP_RVAL_RCC_CFGR_HPRE             9
#elif CHIP_CLK_AHB_DIV == 8
    #define CHIP_RVAL_RCC_CFGR_HPRE             10
#elif CHIP_CLK_AHB_DIV == 16
    #define CHIP_RVAL_RCC_CFGR_HPRE             11
#elif CHIP_CLK_AHB_DIV == 64
    #define CHIP_RVAL_RCC_CFGR_HPRE             12
#elif CHIP_CLK_AHB_DIV == 128
    #define CHIP_RVAL_RCC_CFGR_HPRE             13
#elif CHIP_CLK_AHB_DIV == 256
    #define CHIP_RVAL_RCC_CFGR_HPRE             14
#elif CHIP_CLK_AHB_DIV == 512
    #define CHIP_RVAL_RCC_CFGR_HPRE             15
#else
    #error invalid AHB clock divider
#endif

#if CHIP_CLK_AHB_FREQ > CHIP_CLK_AHB_FREQ_MAX
    #error AHB freq is out of range
#endif

/* -------------------- Проверка частот APB1/APB2 ----------------------------*/
#if CHIP_CLK_APB1_DIV == 1
    #define CHIP_RVAL_RCC_CFGR_PPRE1            0
#elif CHIP_CLK_APB1_DIV == 2
    #define CHIP_RVAL_RCC_CFGR_PPRE1            4
#elif CHIP_CLK_APB1_DIV == 4
    #define CHIP_RVAL_RCC_CFGR_PPRE1            5
#elif CHIP_CLK_APB1_DIV == 8
    #define CHIP_RVAL_RCC_CFGR_PPRE1            6
#elif CHIP_CLK_APB1_DIV == 16
    #define CHIP_RVAL_RCC_CFGR_PPRE1            7
#else
    #error invalid APB1 clock divider
#endif

#if CHIP_CLK_APB1_FREQ > CHIP_CLK_APB1_FREQ_MAX
    #error APB1 freq is out of range
#endif

#if CHIP_CLK_APB2_DIV == 1
    #define CHIP_RVAL_RCC_CFGR_PPRE2            0
#elif CHIP_CLK_APB2_DIV == 2
    #define CHIP_RVAL_RCC_CFGR_PPRE2            4
#elif CHIP_CLK_APB2_DIV == 4
    #define CHIP_RVAL_RCC_CFGR_PPRE2            5
#elif CHIP_CLK_APB2_DIV == 8
    #define CHIP_RVAL_RCC_CFGR_PPRE2            6
#elif CHIP_CLK_APB2_DIV == 16
    #define CHIP_RVAL_RCC_CFGR_PPRE2            7
#else
    #error invalid APB2 clock divider
#endif

#if CHIP_CLK_APB2_FREQ > CHIP_CLK_APB2_FREQ_MAX
    #error APB2 freq is out of range
#endif


#if CHIP_CLK_ADC_DIV == 2
    #define CHIP_RVAL_RCC_CFGR_ADC_PRE   CHIP_REGFLDVAL_RCC_CFGR_ADC_PRE_2
#elif CHIP_CLK_ADC_DIV == 4
    #define CHIP_RVAL_RCC_CFGR_ADC_PRE   CHIP_REGFLDVAL_RCC_CFGR_ADC_PRE_4
#elif CHIP_CLK_ADC_DIV == 6
    #define CHIP_RVAL_RCC_CFGR_ADC_PRE   CHIP_REGFLDVAL_RCC_CFGR_ADC_PRE_6
#elif CHIP_CLK_ADC_DIV == 8
    #define CHIP_RVAL_RCC_CFGR_ADC_PRE   CHIP_REGFLDVAL_RCC_CFGR_ADC_PRE_8
#elif (CHIP_CLK_ADC_DIV == 12) && defined  CHIP_REGFLDVAL_RCC_CFGR_ADC_PRE_12
    #define CHIP_RVAL_RCC_CFGR_ADC_PRE   CHIP_REGFLDVAL_RCC_CFGR_ADC_PRE_12
#elif (CHIP_CLK_ADC_DIV == 16) && defined  CHIP_REGFLDVAL_RCC_CFGR_ADC_PRE_16
    #define CHIP_RVAL_RCC_CFGR_ADC_PRE   CHIP_REGFLDVAL_RCC_CFGR_ADC_PRE_16
#else
    #error invalid ADC frequency divider
#endif

#if (CHIP_CLK_ADC_FREQ > CHIP_CLK_ADC_FREQ_MAX)
    #error ADC frequency is out of range
#endif


/* ----------------------------- определение MCO ----------------------------*/
#if CHIP_CLK_MCO_EN
    #if CHIP_CLK_MCO_SRC_ID == CHIP_CLK_SYS_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_SYSCLK
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_HSI
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_HSE
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_PLL1_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_PLL1_DIV2
    #else
        #error "Invalid MCO source (must be HSI14, LSI, LSE, SYS, HSI, HSE, PLL or HSI48)"
    #endif

    #if !CHIP_CLK_MCO_SRC_EN
        #error MCO source is not eneabled
    #endif
#else
    #define CHIP_RVAL_RCC_CFGR_MCO              CHIP_REGFLDVAL_RCC_CFGR_MCO_DIS
    #define CHIP_RVAL_RCC_CFGR_MCO_PRE          0
    #define CHIP_RVAL_RCC_CFGR_MCO_PLLNODIV     0
#endif


void chip_clk_init(void) {

    /* включение LSI либо если разрешен явно, либо если требуется настройка IWDG.
     * Т.к. IWDG следует разрешить как можно раньше, включаем этот клок до
     * настройки остального */
#if CHIP_CLK_LSI_EN
    CHIP_REGS_RCC->CSR |= CHIP_REGFLD_RCC_CSR_LSI_ON;
#endif

#if CHIP_WDT_SETUP_EN
    /* wdt настраиваем как можно раньше, но нужно убедиться, что его клок уже готов */
    while ((CHIP_REGS_RCC->CSR & CHIP_REGFLD_RCC_CSR_LSI_RDY) != CHIP_REGFLD_RCC_CSR_LSI_RDY) {
        continue;
    }
    chip_wdt_init();
#endif


    /* Если процессор работает не от HSI, то переходим в режим по умолчанию:
     * включаем HSI и ждем готовности, переводим процессор на работу от него */
    if (LBITFIELD_GET(CHIP_REGS_RCC->CFGR,  CHIP_REGFLD_RCC_CFGR_SWS) != CHIP_REGFLDVAL_RCC_CFGR_SW_HSI) {
        CHIP_REGS_RCC->CR |= CHIP_REGFLD_RCC_CR_HSI_ON;


        CHIP_INIT_WAIT((CHIP_REGS_RCC->CR & CHIP_REGFLD_RCC_CR_HSI_RDY) == CHIP_REGFLD_RCC_CR_HSI_RDY,
                           CHIP_INIT_FAULT_WAIT_HSI_RDY, 10000);

        LBITFIELD_UPD(CHIP_REGS_RCC->CFGR, CHIP_REGFLD_RCC_CFGR_SW, CHIP_REGFLDVAL_RCC_CFGR_SW_HSI);
    }

    CHIP_REGS_RCC->CR = (CHIP_REGS_RCC->CR & (CHIP_REGMSK_RCC_CR_RESERVED | CHIP_REGFLD_RCC_CR_HSI_TRIM))
            | CHIP_REGFLD_RCC_CR_HSI_ON
        #if CHIP_CLK_HSE_EN
            | CHIP_REGFLD_RCC_CR_HSE_ON
        #if CHIP_CLK_HSE_MODE == CHIP_CLK_EXTMODE_CLOCK
            | CHIP_REGFLD_RCC_CR_HSE_BYP
        #endif
        #if CHIP_CLK_HSE_CSS_EN
            | CHIP_REGFLD_RCC_CR_CSS_ON
        #endif
        #endif
            ;

    /* ожидание установки всех базовых клоков */
#if CHIP_RVAL_RCC_CR_WTRDY_MSK != 0
    CHIP_INIT_WAIT((CHIP_REGS_RCC->CR & CHIP_RVAL_RCC_CR_WTRDY_MSK) == CHIP_RVAL_RCC_CR_WTRDY_MSK,
                       CHIP_INIT_FAULT_WAIT_HSE_RDY, 10000);
#endif

    /* настройка PLL если требуется */
#if CHIP_CLK_PLL1_EN
    //LBITFIELD_UPD(CHIP_REGS_RCC->CFGR2, CHIP_REGFLD_RCC_CFGR2_PREDIV, CHIP_RVAL_RCC_CFGR2_PREDIV);

    CHIP_REGS_RCC->CFGR = (CHIP_REGS_RCC->CFGR & ~(CHIP_REGMSK_RCC_CFGR_PLL1_MUL
                               | CHIP_REGFLD_RCC_CFGR_PLL1_SRC
                               | CHIP_REGFLD_RCC_CFGR_PLL1_XTPRE))
            | CHIP_REGFLDSET_RCC_CFGR_PLL1_MUL(CHIP_RVAL_RCC_CFGR_PLL1MUL)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_PLL1_SRC, CHIP_RVAL_RCC_CFGR_PLL1SRC)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_PLL1_XTPRE, CHIP_RVAL_RCC_CFG_PLL1XTPRE)
            ;

    /* разрешение PLL и ожидание установки */
    LBITFIELD_UPD(CHIP_REGS_RCC->CR, CHIP_REGFLD_RCC_CR_PLL1_ON, 1);

    CHIP_INIT_WAIT((CHIP_REGS_RCC->CR & CHIP_REGFLD_RCC_CR_PLL1_RDY) == CHIP_REGFLD_RCC_CR_PLL1_RDY,
                   CHIP_INIT_FAULT_WAIT_PLL1_RDY, 10000);
#endif

    /* перед настройкой SYS_CLK устанавливаем нужные параметры LATENCY для flash */
    chip_flash_init();

    /* выбор источника системного клока и делителей шин */
    CHIP_REGS_RCC->CFGR = (CHIP_REGS_RCC->CFGR & ~(CHIP_REGFLD_RCC_CFGR_SW
                               | CHIP_REGFLD_RCC_CFGR_HPRE
                               | CHIP_REGFLD_RCC_CFGR_PPRE1
                               | CHIP_REGFLD_RCC_CFGR_PPRE2
                               | CHIP_REGFLD_RCC_CFGR_MCO
                               | CHIP_REGMSK_RCC_CFGR_ADC_PRE
                            ))
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_SW,        CHIP_RVAL_RCC_CFGR_SW)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_HPRE,      CHIP_RVAL_RCC_CFGR_HPRE)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_PPRE1,     CHIP_RVAL_RCC_CFGR_PPRE1)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_PPRE2,     CHIP_RVAL_RCC_CFGR_PPRE2)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_MCO,       CHIP_RVAL_RCC_CFGR_MCO)
            | CHIP_REGFLDSET_RCC_CFGR_ADC_PRE(CHIP_RVAL_RCC_CFGR_ADC_PRE)
            ;


    CHIP_REGS_RCC->AHBENR = 0
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_DMA1_EN,         CHIP_CLK_DMA1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_DMA2_EN,         CHIP_CLK_DMA2_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_SRAM_EN,         CHIP_CLK_SRAM_EN)
#if !defined CHIP_DEV_CH32XXXX
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_FLITF_EN,        CHIP_CLK_FLASH_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_CRC_EN,          CHIP_CLK_CRC_EN)
#if CHIP_DEV_SUPPORT_EXMC
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_EXMC_EN,         CHIP_CLK_EXMC_EN)
#endif
#if CHIP_DEV_SUPPORT_RNG
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_RNG_EN,          CHIP_CLK_RNG_EN)
#endif
#if CHIP_DEV_SDIO_CNT >= 1
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_SDIO1_EN,        CHIP_CLK_SDIO1_EN)
#endif
#if CHIP_DEV_USBHS_CNT >= 1
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_USBHS_EN,        CHIP_CLK_USBHS_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_USBHD_EN,        CHIP_CLK_USBHD_EN)
#if CHIP_DEV_DVP_CNT >= 1
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_DVP_EN,          CHIP_CLK_DVP_EN)
#endif
#if CHIP_DEV_ETH_CNT >= 1
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_ETH_MAC_EN,      CHIP_CLK_ETH_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_ETH_MAC_TX_EN,   CHIP_CLK_ETH_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_ETH_MAC_RX_EN,   CHIP_CLK_ETH_EN)
#endif
#if CHIP_DEV_BLES_CNT >= 1
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_BLES,            CHIP_CLK_BLES_EN)
#endif
            ;

    CHIP_REGS_RCC->APB2ENR = 0
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_AFIO_EN,        CHIP_CLK_AFIO_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPA_EN,        CHIP_CLK_GPIOA_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPB_EN,        CHIP_CLK_GPIOB_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPC_EN,        CHIP_CLK_GPIOC_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPD_EN,        CHIP_CLK_GPIOD_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPE_EN,        CHIP_CLK_GPIOE_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPF_EN,        CHIP_CLK_GPIOF_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPG_EN,        CHIP_CLK_GPIOG_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_ADC1_EN,        CHIP_CLK_ADC1_EN)
#if CHIP_DEV_ADC_CNT >= 2
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_ADC2_EN,        CHIP_CLK_ADC2_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_TIM1_EN,        CHIP_CLK_TIM1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_SPI1_EN,        CHIP_CLK_SPI1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_USART1_EN,      CHIP_CLK_USART1_EN)
#if CHIP_DEV_ADC_CNT >=3
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_ADC3_EN,        CHIP_CLK_ADC3_EN)
#endif
#if CHIP_DEV_SUPPORT_TIM9
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_TIM9_EN,        CHIP_CLK_TIM9_EN)
#endif
#if CHIP_DEV_SUPPORT_TIM10
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_TIM10_EN,       CHIP_CLK_TIM10_EN)
#endif
#if CHIP_DEV_SUPPORT_TIM11
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_TIM11_EN,       CHIP_CLK_TIM11_EN)
#endif
            ;

    CHIP_REGS_RCC->APB1ENR = 0
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM2_EN,        CHIP_CLK_TIM2_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM3_EN,        CHIP_CLK_TIM3_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM4_EN,        CHIP_CLK_TIM4_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM5_EN,        CHIP_CLK_TIM5_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM6_EN,        CHIP_CLK_TIM6_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM7_EN,        CHIP_CLK_TIM7_EN)
#ifdef  CHIP_DEV_CH32XXX
#if CHIP_DEV_UART_CNT >= 6
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_UART6_EN,       CHIP_CLK_UART6_EN)
#endif
#if CHIP_DEV_UART_CNT >= 7
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_UART7_EN,       CHIP_CLK_UART7_EN)
#endif
#if CHIP_DEV_UART_CNT >= 8
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_UART8_EN,       CHIP_CLK_UART8_EN)
#endif
#else
#if CHIP_DEV_SUPPORT_TIM12
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM12_EN,       CHIP_CLK_TIM12_EN)
#endif
#if CHIP_DEV_SUPPORT_TIM13
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM13_EN,       CHIP_CLK_TIM13_EN)
#endif
#if CHIP_DEV_SUPPORT_TIM14
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM14_EN,       CHIP_CLK_TIM14_EN)
#endif
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_WWDG_EN,        CHIP_CLK_WWDG_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_SPI2_EN,        CHIP_CLK_SPI2_EN)
#if CHIP_DEV_SPI_CNT >= 3
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_SPI3_EN,        CHIP_CLK_SPI3_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_USART2_EN,      CHIP_CLK_USART2_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_USART3_EN,      CHIP_CLK_USART3_EN)
#if CHIP_DEV_UART_CNT >= 4
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_UART4_EN,       CHIP_CLK_UART4_EN)
#endif
#if CHIP_DEV_UART_CNT >= 5
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_UART5_EN,       CHIP_CLK_UART5_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_I2C1_EN,        CHIP_CLK_I2C1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_I2C2_EN,        CHIP_CLK_I2C2_EN)
#ifndef CHIP_DEV_STM32F10X
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_USBD_EN,        CHIP_CLK_USBD_EN)
#endif
#if CHIP_DEV_CAN_CNT >= 1
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_CAN1_EN,        CHIP_CLK_CAN1_EN)
#endif
#if CHIP_DEV_CAN_CNT >= 2
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_CAN2_EN,        CHIP_CLK_CAN2_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_BKP_EN,         CHIP_CLK_BKP_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_PWR_EN,         CHIP_CLK_PWR_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_DAC_EN,         CHIP_CLK_DAC_EN)
            ;

#if CHIP_CLK_MCO_EN
    CHIP_PIN_CONFIG(CHIP_PIN_PA8_MCO);
#endif
#if CHIP_LTIMER_EN
    /* разрешение ltimer */
    lclock_init();
#endif
}
